<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [HttpServicePreboot](./kibana-plugin-core-server.httpservicepreboot.md) &gt; [registerRoutes](./kibana-plugin-core-server.httpservicepreboot.registerroutes.md)

## HttpServicePreboot.registerRoutes() method

Provides ability to acquire `preboot` [IRouter](./kibana-plugin-core-server.irouter.md) instance for a particular top-level path and register handler functions for any number of nested routes.

**Signature:**

```typescript
registerRoutes(path: string, callback: (router: IRouter) => void): void;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  path | string |  |
|  callback | (router: IRouter) =&gt; void |  |

**Returns:**

void

## Remarks

Each route can have only one handler function, which is executed when the route is matched. See the [IRouter](./kibana-plugin-core-server.irouter.md) documentation for more information.

## Example


```ts
registerRoutes('my-plugin', (router) => {
  // handler is called when '/my-plugin/path' resource is requested with `GET` method
  router.get({ path: '/path', validate: false }, (context, req, res) => res.ok({ content: 'ok' }));
});
```

