<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [HttpServiceSetup](./kibana-plugin-core-server.httpservicesetup.md) &gt; [registerRouteHandlerContext](./kibana-plugin-core-server.httpservicesetup.registerroutehandlercontext.md)

## HttpServiceSetup.registerRouteHandlerContext property

Register a context provider for a route handler.

**Signature:**

```typescript
registerRouteHandlerContext: <Context extends RequestHandlerContext, ContextName extends keyof Context>(contextName: ContextName, provider: RequestHandlerContextProvider<Context, ContextName>) => RequestHandlerContextContainer;
```

## Example


```ts
 // my-plugin.ts
 interface MyRequestHandlerContext extends RequestHandlerContext {
   myApp: { search(id: string): Promise<Result> };
 }
 deps.http.registerRouteHandlerContext<MyRequestHandlerContext, 'myApp'>(
   'myApp',
   (context, req) => {
    async function search (id: string) {
      return await context.elasticsearch.client.asCurrentUser.find(id);
    }
    return { search };
   }
 );

// my-route-handler.ts
 import type { MyRequestHandlerContext } from './my-plugin.ts';
 const router = createRouter<MyRequestHandlerContext>();
 router.get({ path: '/', validate: false }, async (context, req, res) => {
   const response = await context.myApp.search(...);
   return res.ok(response);
 });
```

