<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [KibanaRequest](./kibana-plugin-core-server.kibanarequest.md)

## KibanaRequest class

Kibana specific abstraction for an incoming request.

**Signature:**

```typescript
export declare class KibanaRequest<Params = unknown, Query = unknown, Body = unknown, Method extends RouteMethod = any> 
```

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(request, params, query, body, withoutSecretHeaders)](./kibana-plugin-core-server.kibanarequest._constructor_.md) |  | Constructs a new instance of the <code>KibanaRequest</code> class |

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [auth](./kibana-plugin-core-server.kibanarequest.auth.md) | <code>readonly</code> | { isAuthenticated: boolean; } |  |
|  [body](./kibana-plugin-core-server.kibanarequest.body.md) | <code>readonly</code> | Body |  |
|  [events](./kibana-plugin-core-server.kibanarequest.events.md) | <code>readonly</code> | KibanaRequestEvents | Request events [KibanaRequestEvents](./kibana-plugin-core-server.kibanarequestevents.md) |
|  [headers](./kibana-plugin-core-server.kibanarequest.headers.md) | <code>readonly</code> | Headers | Readonly copy of incoming request headers. |
|  [id](./kibana-plugin-core-server.kibanarequest.id.md) | <code>readonly</code> | string | A identifier to identify this request. |
|  [isSystemRequest](./kibana-plugin-core-server.kibanarequest.issystemrequest.md) | <code>readonly</code> | boolean | Whether or not the request is a "system request" rather than an application-level request. Can be set on the client using the <code>HttpFetchOptions#asSystemRequest</code> option. |
|  [params](./kibana-plugin-core-server.kibanarequest.params.md) | <code>readonly</code> | Params |  |
|  [query](./kibana-plugin-core-server.kibanarequest.query.md) | <code>readonly</code> | Query |  |
|  [rewrittenUrl?](./kibana-plugin-core-server.kibanarequest.rewrittenurl.md) | <code>readonly</code> | URL | _(Optional)_ URL rewritten in onPreRouting request interceptor. |
|  [route](./kibana-plugin-core-server.kibanarequest.route.md) | <code>readonly</code> | RecursiveReadonly&lt;KibanaRequestRoute&lt;Method&gt;&gt; | matched route details |
|  [socket](./kibana-plugin-core-server.kibanarequest.socket.md) | <code>readonly</code> | IKibanaSocket | [IKibanaSocket](./kibana-plugin-core-server.ikibanasocket.md) |
|  [url](./kibana-plugin-core-server.kibanarequest.url.md) | <code>readonly</code> | URL | a WHATWG URL standard object. |
|  [uuid](./kibana-plugin-core-server.kibanarequest.uuid.md) | <code>readonly</code> | string | A UUID to identify this request. |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [\[inspect.custom\]()](./kibana-plugin-core-server.kibanarequest._inspect.custom_.md) |  |  |
|  [toJSON()](./kibana-plugin-core-server.kibanarequest.tojson.md) |  |  |
|  [toString()](./kibana-plugin-core-server.kibanarequest.tostring.md) |  |  |

