<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [PrebootServicePreboot](./kibana-plugin-core-server.prebootservicepreboot.md)

## PrebootServicePreboot interface

Kibana Preboot Service allows to control the boot flow of Kibana. Preboot plugins can use it to hold the boot until certain condition is met.

**Signature:**

```typescript
export interface PrebootServicePreboot 
```

## Example

A plugin can supply a `Promise` to a `holdSetupUntilResolved` method to signal Kibana to initialize and start `standard` plugins only after this `Promise` is resolved. If `Promise` is rejected, Kibana will shut down.

```ts
core.preboot.holdSetupUntilResolved('Just waiting for 5 seconds',
  new Promise((resolve) => {
    setTimeout(resolve, 5000);
  })
);
```
If the supplied `Promise` resolves to an object with the `shouldReloadConfig` property set to `true`<!-- -->, Kibana will also reload its configuration from disk.

```ts
let completeSetup: (result: { shouldReloadConfig: boolean }) => void;
core.preboot.holdSetupUntilResolved('Just waiting for 5 seconds before reloading configuration',
  new Promise<{ shouldReloadConfig: boolean }>((resolve) => {
    setTimeout(() => resolve({ shouldReloadConfig: true }), 5000);
  })
);
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [holdSetupUntilResolved](./kibana-plugin-core-server.prebootservicepreboot.holdsetupuntilresolved.md) | <code>readonly</code> | (reason: string, promise: Promise&lt;{ shouldReloadConfig: boolean; } \| undefined&gt;) =&gt; void | Registers a <code>Promise</code> as a precondition before Kibana can proceed to <code>setup</code>. This method can be invoked multiple times and from multiple <code>preboot</code> plugins. Kibana will proceed to <code>setup</code> only when all registered <code>Promises</code> instances are resolved, or it will shut down if any of them is rejected. |
|  [isSetupOnHold](./kibana-plugin-core-server.prebootservicepreboot.issetuponhold.md) | <code>readonly</code> | () =&gt; boolean | Indicates whether Kibana is currently on hold and cannot proceed to <code>setup</code> yet. |

