<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [SavedObjectMigrationFn](./kibana-plugin-core-server.savedobjectmigrationfn.md)

## SavedObjectMigrationFn type

A migration function for a [saved object type](./kibana-plugin-core-server.savedobjectstype.md) used to migrate it to a given version

**Signature:**

```typescript
export declare type SavedObjectMigrationFn<InputAttributes = unknown, MigratedAttributes = unknown> = (doc: SavedObjectUnsanitizedDoc<InputAttributes>, context: SavedObjectMigrationContext) => SavedObjectUnsanitizedDoc<MigratedAttributes>;
```

## Example


```typescript
interface TypeV1Attributes {
  someKey: string;
  obsoleteProperty: number;
}

interface TypeV2Attributes {
  someKey: string;
  newProperty: string;
}

const migrateToV2: SavedObjectMigrationFn<TypeV1Attributes, TypeV2Attributes> = (doc, { log }) => {
  const { obsoleteProperty, ...otherAttributes } = doc.attributes;
  // instead of mutating `doc` we make a shallow copy so that we can use separate types for the input
  // and output attributes. We don't need to make a deep copy, we just need to ensure that obsolete
  // attributes are not present on the returned doc.
  return {
    ...doc,
    attributes: {
      ...otherAttributes,
      newProperty: migrate(obsoleteProperty),
    },
  };
};
```

