<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [SavedObjectsClient](./kibana-plugin-core-server.savedobjectsclient.md) &gt; [bulkResolve](./kibana-plugin-core-server.savedobjectsclient.bulkresolve.md)

## SavedObjectsClient.bulkResolve() method

Resolves an array of objects by id, using any legacy URL aliases if they exist

**Signature:**

```typescript
bulkResolve<T = unknown>(objects: SavedObjectsBulkResolveObject[], options?: SavedObjectsBaseOptions): Promise<SavedObjectsBulkResolveResponse<T>>;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  objects | SavedObjectsBulkResolveObject\[\] | an array of objects containing id, type |
|  options | SavedObjectsBaseOptions | _(Optional)_ |

**Returns:**

Promise&lt;SavedObjectsBulkResolveResponse&lt;T&gt;&gt;

## Example

bulkResolve(\[ { id: 'one', type: 'config' }<!-- -->, { id: 'foo', type: 'index-pattern' } \])

 Saved objects that Kibana fails to find are replaced with an error object and an "exactMatch" outcome. The rationale behind the outcome is that "exactMatch" is the default outcome, and the outcome only changes if an alias is found. This behavior is unique to `bulkResolve`<!-- -->; the regular `resolve` API will throw an error instead.

