<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [SavedObjectsRepository](./kibana-plugin-core-server.savedobjectsrepository.md) &gt; [openPointInTimeForType](./kibana-plugin-core-server.savedobjectsrepository.openpointintimefortype.md)

## SavedObjectsRepository.openPointInTimeForType() method

Opens a Point In Time (PIT) against the indices for the specified Saved Object types. The returned `id` can then be passed to `SavedObjects.find` to search against that PIT.

Only use this API if you have an advanced use case that's not solved by the [SavedObjectsRepository.createPointInTimeFinder()](./kibana-plugin-core-server.savedobjectsrepository.createpointintimefinder.md) method.

**Signature:**

```typescript
openPointInTimeForType(type: string | string[], { keepAlive, preference }?: SavedObjectsOpenPointInTimeOptions): Promise<SavedObjectsOpenPointInTimeResponse>;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  type | string \| string\[\] |  |
|  { keepAlive, preference } | SavedObjectsOpenPointInTimeOptions | _(Optional)_ |

**Returns:**

Promise&lt;SavedObjectsOpenPointInTimeResponse&gt;

{<!-- -->promise<!-- -->} - { id: string }

## Example


```ts
const { id } = await savedObjectsClient.openPointInTimeForType(
  type: 'visualization',
  { keepAlive: '5m' },
);
const page1 = await savedObjectsClient.find({
  type: 'visualization',
  sortField: 'updated_at',
  sortOrder: 'asc',
  pit: { id, keepAlive: '2m' },
});
const lastHit = page1.saved_objects[page1.saved_objects.length - 1];
const page2 = await savedObjectsClient.find({
  type: 'visualization',
  sortField: 'updated_at',
  sortOrder: 'asc',
  pit: { id: page1.pit_id },
  searchAfter: lastHit.sort,
});
await savedObjectsClient.closePointInTime(page2.pit_id);
```

