<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [SavedObjectsServiceSetup](./kibana-plugin-core-server.savedobjectsservicesetup.md)

## SavedObjectsServiceSetup interface

Saved Objects is Kibana's data persistence mechanism allowing plugins to use Elasticsearch for storing and querying state. The SavedObjectsServiceSetup API exposes methods for registering Saved Object types, creating and registering Saved Object client wrappers and factories.

**Signature:**

```typescript
export interface SavedObjectsServiceSetup 
```

## Remarks

When plugins access the Saved Objects client, a new client is created using the factory provided to `setClientFactory` and wrapped by all wrappers registered through `addClientWrapper`<!-- -->.

## Example 1


```ts
import { SavedObjectsClient, CoreSetup } from 'src/core/server';

export class Plugin() {
  setup: (core: CoreSetup) => {
    core.savedObjects.setClientFactory(({ request: KibanaRequest }) => {
      return new SavedObjectsClient(core.savedObjects.scopedRepository(request));
    })
  }
}
```

## Example 2


```ts
import { SavedObjectsClient, CoreSetup } from 'src/core/server';
import { mySoType } from './saved_objects'

export class Plugin() {
  setup: (core: CoreSetup) => {
    core.savedObjects.registerType(mySoType);
  }
}
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [addClientWrapper](./kibana-plugin-core-server.savedobjectsservicesetup.addclientwrapper.md) |  | (priority: number, id: string, factory: SavedObjectsClientWrapperFactory) =&gt; void | Add a [client wrapper factory](./kibana-plugin-core-server.savedobjectsclientwrapperfactory.md) with the given priority. |
|  [registerType](./kibana-plugin-core-server.savedobjectsservicesetup.registertype.md) |  | &lt;Attributes = any&gt;(type: SavedObjectsType&lt;Attributes&gt;) =&gt; void | <p>Register a [savedObjects type](./kibana-plugin-core-server.savedobjectstype.md) definition.</p><p>See the [mappings format](./kibana-plugin-core-server.savedobjectstypemappingdefinition.md) and [migration format](./kibana-plugin-core-server.savedobjectmigrationmap.md) for more details about these.</p> |
|  [setClientFactoryProvider](./kibana-plugin-core-server.savedobjectsservicesetup.setclientfactoryprovider.md) |  | (clientFactoryProvider: SavedObjectsClientFactoryProvider) =&gt; void | Set the default [factory provider](./kibana-plugin-core-server.savedobjectsclientfactoryprovider.md) for creating Saved Objects clients. Only one provider can be set, subsequent calls to this method will fail. |

