<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [SavedObjectsTypeManagementDefinition](./kibana-plugin-core-server.savedobjectstypemanagementdefinition.md) &gt; [onImport](./kibana-plugin-core-server.savedobjectstypemanagementdefinition.onimport.md)

## SavedObjectsTypeManagementDefinition.onImport property

An optional [import hook](./kibana-plugin-core-server.savedobjectsimporthook.md) to use when importing given type.

Import hooks are executed during the savedObjects import process and allow to interact with the imported objects. See the [hook documentation](./kibana-plugin-core-server.savedobjectsimporthook.md) for more info.

**Signature:**

```typescript
onImport?: SavedObjectsImportHook<Attributes>;
```

## Remarks

`importableAndExportable` must be `true` to specify this property.

## Example

Registering a hook displaying a warning about a specific type of object

```ts
// src/plugins/my_plugin/server/plugin.ts
import { myType } from './saved_objects';

export class Plugin() {
  setup: (core: CoreSetup) => {
    core.savedObjects.registerType({
       ...myType,
       management: {
         ...myType.management,
         onImport: (objects) => {
           if(someActionIsNeeded(objects)) {
             return {
                warnings: [
                  {
                    type: 'action_required',
                    message: 'Objects need to be manually enabled after import',
                    actionPath: '/app/my-app/require-activation',
                  },
                ]
             }
           }
           return {};
         }
       },
    });
  }
}
```

