<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [SavedObjectTypeRegistry](./kibana-plugin-core-server.savedobjecttyperegistry.md)

## SavedObjectTypeRegistry class

Registry holding information about all the registered [saved object types](./kibana-plugin-core-server.savedobjectstype.md)<!-- -->.

**Signature:**

```typescript
export declare class SavedObjectTypeRegistry 
```

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [getAllTypes()](./kibana-plugin-core-server.savedobjecttyperegistry.getalltypes.md) |  | <p>Return all [types](./kibana-plugin-core-server.savedobjectstype.md) currently registered, including the hidden ones.</p><p>To only get the visible types (which is the most common use case), use <code>getVisibleTypes</code> instead.</p> |
|  [getImportableAndExportableTypes()](./kibana-plugin-core-server.savedobjecttyperegistry.getimportableandexportabletypes.md) |  | Return all [types](./kibana-plugin-core-server.savedobjectstype.md) currently registered that are importable/exportable. |
|  [getIndex(type)](./kibana-plugin-core-server.savedobjecttyperegistry.getindex.md) |  | Returns the <code>indexPattern</code> property for given type, or <code>undefined</code> if the type is not registered. |
|  [getType(type)](./kibana-plugin-core-server.savedobjecttyperegistry.gettype.md) |  | Return the [type](./kibana-plugin-core-server.savedobjectstype.md) definition for given type name. |
|  [getVisibleTypes()](./kibana-plugin-core-server.savedobjecttyperegistry.getvisibletypes.md) |  | <p>Returns all visible [types](./kibana-plugin-core-server.savedobjectstype.md)<!-- -->.</p><p>A visible type is a type that doesn't explicitly define <code>hidden=true</code> during registration.</p> |
|  [isHidden(type)](./kibana-plugin-core-server.savedobjecttyperegistry.ishidden.md) |  | Returns the <code>hidden</code> property for given type, or <code>false</code> if the type is not registered. |
|  [isImportableAndExportable(type)](./kibana-plugin-core-server.savedobjecttyperegistry.isimportableandexportable.md) |  | Returns the <code>management.importableAndExportable</code> property for given type, or <code>false</code> if the type is not registered or does not define a management section. |
|  [isMultiNamespace(type)](./kibana-plugin-core-server.savedobjecttyperegistry.ismultinamespace.md) |  | Returns whether the type is multi-namespace (shareable \*or\* isolated); resolves to <code>false</code> if the type is not registered |
|  [isNamespaceAgnostic(type)](./kibana-plugin-core-server.savedobjecttyperegistry.isnamespaceagnostic.md) |  | Returns whether the type is namespace-agnostic (global); resolves to <code>false</code> if the type is not registered |
|  [isShareable(type)](./kibana-plugin-core-server.savedobjecttyperegistry.isshareable.md) |  | Returns whether the type is multi-namespace (shareable); resolves to <code>false</code> if the type is not registered |
|  [isSingleNamespace(type)](./kibana-plugin-core-server.savedobjecttyperegistry.issinglenamespace.md) |  | Returns whether the type is single-namespace (isolated); resolves to <code>true</code> if the type is not registered |
|  [registerType(type)](./kibana-plugin-core-server.savedobjecttyperegistry.registertype.md) |  | Register a [type](./kibana-plugin-core-server.savedobjectstype.md) inside the registry. A type can only be registered once. subsequent calls with the same type name will throw an error. |

