<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [UiSettingsParams](./kibana-plugin-core-server.uisettingsparams.md)

## UiSettingsParams interface

UiSettings parameters defined by the plugins.

**Signature:**

```typescript
export interface UiSettingsParams<T = unknown> 
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [category?](./kibana-plugin-core-server.uisettingsparams.category.md) |  | string\[\] | _(Optional)_ used to group the configured setting in the UI |
|  [deprecation?](./kibana-plugin-core-server.uisettingsparams.deprecation.md) |  | DeprecationSettings | _(Optional)_ optional deprecation information. Used to generate a deprecation warning. |
|  [description?](./kibana-plugin-core-server.uisettingsparams.description.md) |  | string | _(Optional)_ description provided to a user in UI |
|  [metric?](./kibana-plugin-core-server.uisettingsparams.metric.md) |  | { type: UiCounterMetricType; name: string; } | _(Optional)_ Metric to track once this property changes |
|  [name?](./kibana-plugin-core-server.uisettingsparams.name.md) |  | string | _(Optional)_ title in the UI |
|  [optionLabels?](./kibana-plugin-core-server.uisettingsparams.optionlabels.md) |  | Record&lt;string, string&gt; | _(Optional)_ text labels for 'select' type UI element |
|  [options?](./kibana-plugin-core-server.uisettingsparams.options.md) |  | string\[\] | _(Optional)_ array of permitted values for this setting |
|  [order?](./kibana-plugin-core-server.uisettingsparams.order.md) |  | number | <p>_(Optional)_ index of the settings within its category (ascending order, smallest will be displayed first). Used for ordering in the UI.</p><p> settings without order defined will be displayed last and ordered by name</p> |
|  [readonly?](./kibana-plugin-core-server.uisettingsparams.readonly.md) |  | boolean | _(Optional)_ a flag indicating that value cannot be changed |
|  [requiresPageReload?](./kibana-plugin-core-server.uisettingsparams.requirespagereload.md) |  | boolean | _(Optional)_ a flag indicating whether new value applying requires page reloading |
|  [schema](./kibana-plugin-core-server.uisettingsparams.schema.md) |  | Type&lt;T&gt; |  |
|  [sensitive?](./kibana-plugin-core-server.uisettingsparams.sensitive.md) |  | boolean | _(Optional)_ a flag indicating that value might contain user sensitive data. used by telemetry to mask the value of the setting when sent. |
|  [type?](./kibana-plugin-core-server.uisettingsparams.type.md) |  | UiSettingsType | _(Optional)_ defines a type of UI element [UiSettingsType](./kibana-plugin-core-server.uisettingstype.md) |
|  [value?](./kibana-plugin-core-server.uisettingsparams.value.md) |  | T | _(Optional)_ default value to fall back to if a user doesn't provide any |

